# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class Volume(pulumi.CustomResource):
    driver: pulumi.Output[str]
    """
    Driver type for the volume (defaults to local).
    """
    driver_opts: pulumi.Output[dict]
    """
    Options specific to the driver.
    """
    labels: pulumi.Output[dict]
    """
    User-defined key/value metadata.
    """
    mountpoint: pulumi.Output[str]
    name: pulumi.Output[str]
    """
    The name of the Docker volume (generated if not
    provided).
    """
    def __init__(__self__, resource_name, opts=None, driver=None, driver_opts=None, labels=None, name=None, __name__=None, __opts__=None):
        """
        Creates and destroys a volume in Docker. This can be used alongside
        [docker\_container](https://www.terraform.io/docs/providers/docker/r/container.html)
        to prepare volumes that can be shared across containers.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] driver: Driver type for the volume (defaults to local).
        :param pulumi.Input[dict] driver_opts: Options specific to the driver.
        :param pulumi.Input[dict] labels: User-defined key/value metadata.
        :param pulumi.Input[str] name: The name of the Docker volume (generated if not
               provided).
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['driver'] = driver

        __props__['driver_opts'] = driver_opts

        __props__['labels'] = labels

        __props__['name'] = name

        __props__['mountpoint'] = None

        super(Volume, __self__).__init__(
            'docker:index/volume:Volume',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

